/*

B-Free Project ʪ GNU Generic PUBLIC LICENSE ˽ޤ

GNU GENERAL PUBLIC LICENSE
Version 2, June 1991

(C) B-Free Project.

(C) 2002, Tomohide Naniwa

*/
/* misc.h ---
 *
 *
 */

#ifndef __ITRON_MISC_H__
#define __ITRON_MISC_H__	1

#ifdef notdef
#define ROUNDUP(x,align)	(((((int)x) + ((align) - 1))/(align))*(align))
#define CUTDOWN(x,align)	(((unsigned long)x) / ((unsigned long)align) * ((unsigned long)align))
#endif

/* 2 ѾǤȤʤΨɤ */
#define ROUNDUP(x,align)	((((int)x) + (align) - 1) & ~((align) - 1))
#define CUTDOWN(x,align)	((((int)x) & ~((align) - 1)))

#define TABLE_SIZE(table)	(sizeof(table) / sizeof(table[0]))
#define ISDIGIT(x)		((x >= '0') && (x <= '9'))
#define MAX(a,b)		((a > b) ? a : b)
#define MIN(a,b)		((a < b) ? a : b)

#define PAGES(x)		(ROUNDUP(x, PAGE_SIZE) >> PAGE_SHIFT)


#define ASSERT(exp,mes)		\
if (exp) \
{\
   printk ("ASSERT (%s %d): %s\n", __FILE__, __LINE__, mes); \
}
  

/* rtov --- ¥ꥢɥ쥹ۥꥢɥ쥹Ѵ롣
 */
#define RTOV(real)	((real)  | 0x80000000UL)
#define VTOR(vaddr)	((vaddr) & 0x7FFFFFFFL)

/* ptov --- ¥Υڡֹ椫鲾ۥꥢɥ쥹Ф
 */
#define PTOV(page)	((page << PAGE_SHIFT) | 0x80000000UL)


#endif /* __ITRON_MISC_H__ */
